import java.awt.*;
import java.awt.event.*;
import java.applet.AudioClip;
import java.io.*;

public class Main extends java.applet.Applet
    implements Runnable, KeyListener
{
    game.Lines lines;
    game.Sprite medBall;
    game.Ground grnd;
    game.Stars stars;
    game.TextScroll banner;
    
    boolean keyWasPressed = false;
    
    private AudioClip music;
         
    private int mouseX = 0, mouseY = 0;
    private boolean followMouse = false;

    // _____________________

    Thread killme = null;

    public void start()
    {
        setAll();
        if( killme == null )
        {
            killme = new Thread(this);
            killme.start();
        }
    }

    public void stop()
    {
      	killme = null;
    }

    public void run()
    {
        while (killme != null)
        {
            try { Thread.sleep(100); }
            catch (InterruptedException e) {}

            updateAll();
        }
        killme = null;
    }

    // _____________________

    /*
    public void processMouseEvent(MouseEvent e)
    {
        mouseX = e.getX();
        mouseY = e.getY();
    }
    */

    public boolean handleEvent(Event e)
    {
        if (
                e.id == Event.MOUSE_MOVE
           )
        {
            followMouse = true;
            mouseX = e.x;
            mouseY = e.y;
	  }

        return true;
    }

    public void keyTyped(KeyEvent e)
    {
        keyWasPressed = true;
    }

    public void keyPressed(KeyEvent e)
    {
        keyWasPressed = true;
    }

    public void keyReleased(KeyEvent e)
    {
    }

    // _____________________

    private void setAll()
    {
        this.setBackground( new Color(0,0,0) );

        stars = new game.Stars();
        lines = new game.Lines();
        medBall = new game.Sprite(15,15,200,30,50);
        grnd = new game.Ground(630,400,0,0,0);

        banner = new game.TextScroll
        (
            getParameter("scrolltext"), 
            grnd.getWidth()*2,
            200, 150, 50,
            -1
        );
        banner.position( new game.Point( grnd.getWidth()-10, 360 ) );
        banner.setFontName("Courier");
        banner.setFontSize(20);
        banner.push(-4,0);

        grnd.setPosition(0,0);
        stars.setSprites(grnd);
        lines.setSprites(grnd);

        music = getAudioClip( getCodeBase(), getParameter("soundFile") );
        music.loop();
    }

    private void updateAll()
    {
        game.Point med = new game.Point();
        med = lines.calcPosSpr(grnd, mouseX, mouseY, followMouse);
        medBall.position(med);
        stars.calcPosSpr(grnd);
        banner.calcPosSpr(grnd);
        if ( !keyWasPressed )
            repaint();
        followMouse = false;
    }

    public void paint(Graphics graph)
    {
        stars.spritesAppear( graph, grnd );
        banner.appear(graph, grnd);
        lines.spritesAppear( graph, grnd, medBall.getPoint() );
    }

}


