package game;

import java.awt.*;
import java.awt.Font;

public class TextScroll extends Sprite
{
    final static int blinkPause = 4;

    private String text = "";
    private int fontSize = 36;
    private String fontName = "TimesRoman";
    private boolean blink = false;
    private int loops;
    private int blinkCount = 0;
    
    public TextScroll( String parText, int parWidth, int r, int g, int b, int parLoop )
    {
        super ( parWidth, 20, r, g, b );

        text = parText;

        loops = ( parLoop >= 1 ) ? parLoop: 10000;
    }

    public void setText(String _text)
    {
        text = _text;
    }
    public void setFontSize(int _fontSize)
    {
        fontSize = _fontSize;
    }
    public void setFontName(String _fontName)
    {
        fontName = _fontName;
    }
    public void setBlink(boolean _blink)
    {
        blink = _blink;
    }

    public void appear(Graphics graph, Ground grnd)
    {
        if ( loops>0 )
        {
            if ( !blink || activeBlink() )
            {
                graph.setColor( col );
                graph.setFont( new Font( fontName, Font.BOLD, fontSize ) );
                graph.drawString( text, (int) x + grnd.getOffsetX(), (int) y + grnd.getOffsetY());
            }
        }
    }

    private boolean activeBlink()
    {
        if ( ++blinkCount == blinkPause )
            blinkCount = -blinkPause;

        return ( blinkCount>0 );
    }

    public void calcPosSpr(Ground grnd)
    {
        if ( loops>0 )
        {
            boolean wasShifted = false;
            move(grnd);
            wasShifted = shiftDisappear(grnd);
            if ( wasShifted ) loops--;
        }
    }

}
